using Castle.DynamicProxy;
using Castle.DynamicProxy.Invocation;
using System;
using System.Collections.Specialized;
using System.Reflection;
using System.Runtime;
using System.Threading;

[Serializable]
public class CProxyTypeRealA0 : RealA
{
	// Field定义
	[NonSerialized]
	public HybridDictionary __cache;
	public IInterceptor __interceptor;
	public object[] __mixin;
	public __delegate_1 _cached_1;
	public __delegate_2 _cached_2;
	public __delegate_3 _cached_3;
	public __delegate_4 _cached_4;
	
    //构造函数
    public CProxyTypeRealA0(IInterceptor interceptor1)
	{
		//保存拦截器
		this.__interceptor = interceptor1;
      	this.__cache = new HybridDictionary();
     	this.__mixin = new object[0];
		//DoSomething的代理
      	this._cached_1 = new CProxyTypeRealA0.__delegate_1(
													this, callback__DoSomething);
		
		//以下是重写的一些方法的代理
      	this._cached_2 = new CProxyTypeRealA0.__delegate_2(
													this, callback__GetHashCode);
      	this._cached_3 = new CProxyTypeRealA0.__delegate_3(
													this, callback__Equals);
      	this._cached_4 = new CProxyTypeRealA0.__delegate_4(
													this, callback__ToString);
	}
	
    public override IInvocation _Method2Invocation(ICallable callable1, MethodInfo info1)
	{
		IInvocation invocation1;
	    lock (this)
	    {
			//获取已经缓存的拦截器
	        invocation1 = (IInvocation) this.__cache[info1];
	        if (invocation1 != null)
	        {
				//如果拦截器已经缓存并找到，直接返回拦截器
	            return invocation1;
	        }
			//如果拦截器没有缓存或没有找到，创建一个，并返回。
			//在这里将要调用的方法的代理传给了拦截器的构造函数，
			//这样就允许在拦截后调用原来的方法。
	        invocation1 = new SameClassInvocation(callable1, this, info1);
	        this.__cache.Add(info1, invocation1);
	    }
	    return invocation1;
	}
	
	//DoSomething的回调方法
	public override void callback__DoSomething()
	{
		base.DoSomething();
	}
	
	//重写的DoSomething方法
	//这里将允许拦截并调用原来的DoSomething方法。
	public override void DoSomething()
	{
		IInvocation local0;
		object local1;
		object[] local2;
		
		//获取拦截器
		local0 = this._Method2Invocation(this._cached_1, 
			(MethodInfo) MethodBase.GetMethodFromHandle(
				<{ class ILEngineer::Ops::MSIL::LoadToken }>)
				);
		//构造参数数组
		local2 = new Object[0];
		//调用拦截器的Intercept方法，开始执行
		local1 = this.__interceptor.Intercept(local0, local2);
	}
	
	//其他回调方法
	public override bool callback__Equals(object obj1)
	{
		return base.Equals(obj1);
	}
	
	public override int callback__GetHashCode()
	{
		return base.GetHashCode();
	}
	
	public override string callback__ToString()
	{
		return base.ToString();
	}
	
	//覆盖的父类的需要拦截的方法
	public override bool Equals(object obj1)
	{
		IInvocation local0;
		object local1;
		object[] local2;

		local0 = this._Method2Invocation(this._cached_3, 
			(MethodInfo) MethodBase.GetMethodFromHandle(
				<{ class ILEngineer::Ops::MSIL::LoadToken }>)
				);
		local2 = new Object[0];
		local1 = this.__interceptor.Intercept(local0, local2);
		return (String) local1;
	}
	
	public override int GetHashCode()
	{
		IInvocation local0;
		object local1;
		object[] local2;

		local0 = this._Method2Invocation(this._cached_2, 
			(MethodInfo) MethodBase.GetMethodFromHandle(
				<{ class ILEngineer::Ops::MSIL::LoadToken }>)
				);
		local2 = new Object[0];
		local1 = this.__interceptor.Intercept(local0, local2);
		return (String) local1;
	}
	
	public override string ToString()
	{
		IInvocation local0;
		object local1;
		object[] local2;

		local0 = this._Method2Invocation(this._cached_4, 
			(MethodInfo) MethodBase.GetMethodFromHandle(
				<{ class ILEngineer::Ops::MSIL::LoadToken }>)
				);
		local2 = new Object[0];
		local1 = this.__interceptor.Intercept(local0, local2);
		return (String) local1;
	}
}

public sealed class __delegate_1 : MulticastDelegate, ICallable
{
	public override object Target
	{
		get	{return base.Target;}
	}
	public __delegate_1(object local, IntPtr i);
	public override void Invoke();
	public override object Call(object[] locals)
	{
		base.Invoke();
		return null;
	}
}
public sealed class __delegate_2 : MulticastDelegate, ICallable
{
	public override object Target
	{
		get	{return base.Target;}
	}
	public __delegate_2(object local, IntPtr i);
	public override int Invoke();
	public override object Call(object[] locals)
	{
		return base.Invoke();
	}
}
public sealed class __delegate_3 : MulticastDelegate, ICallable
{
	public override object Target
	{
		get	{return base.Target;}
	}
	public __delegate_3(object local, IntPtr i);
	public override bool Invoke(object local);
	public override object Call(object[] locals)
	{
		return base.Invoke(locals[0]);
	}
}
public sealed class __delegate_4 : MulticastDelegate, ICallable
{
	public override object Target
	{
		get	{return base.Target;}
	}
	public __delegate_4(object local, IntPtr i);
	public override string Invoke();
	public override object Call(object[] locals)
	{
		return base.Invoke();
	}
}
 
